module Sol_Map2 (
    Map, empty, insert, lookup, delete, mapV, keys,
    {- für Teilaufgabe 2 -} kvList, fold) where

import Prelude hiding (lookup)

data Map k v = Empty | Node k v (Map k v) (Map k v)

empty :: Ord k => Map k v
empty = Empty

insert :: Ord k => k -> v -> Map k v -> Map k v
insert k v Empty = Node k v Empty Empty
insert k v (Node k' v' l r) = case compare k k' of
    LT -> Node k' v' (insert k v l) r
    EQ -> Node k' v l r
    GT -> Node k' v' l (insert k v r)

lookup :: Ord k => k -> Map k v -> Maybe v
lookup k Empty = Nothing
lookup k (Node k' v' l r) = case compare k k' of
    LT -> lookup k l
    EQ -> Just v'
    GT -> lookup k r

delete :: Ord k => k -> Map k v -> Map k v
delete k Empty = Empty
delete k (Node k' v' l r) = case compare k k' of
    LT -> Node k' v' (delete k l) r
    EQ -> combine l r
    GT -> Node k' v' l (delete k r)

combine :: Ord k => Map k v -> Map k v -> Map k v
combine Empty r = r
combine l Empty = l
combine n@(Node k v l1 r1) r = case pullOutRight r1 of
    Nothing -> Node k v l1 r
    Just (k', v', r1') -> Node k' v' (Node k v l1 r1') r

pullOutRight :: Ord k => Map k v -> Maybe (k, v, Map k v)
pullOutRight Empty = Nothing
pullOutRight n@(Node k v l r) = case pullOutRight r of
    Nothing -> Just (k,v,l)
    Just (k',v',r') -> Just (k', v', Node k v l r')

mapV :: Ord k => (v -> w) -> Map k v -> Map k w
mapV f Empty = Empty
mapV f (Node k v l r) = Node k (f v) (mapV f l) (mapV f r)

keys :: Ord k => Map k v -> [k]
keys Empty = []
keys (Node k _ l r) = k : keys l ++ keys r

kvList :: Ord k => Map k v -> [(k,v)]
kvList Empty = []
kvList (Node k v l r) = (k,v) : kvList l ++ kvList r

fold :: Ord k => (k -> v -> a -> a) -> a -> Map k v -> a
fold f s Empty = s
fold f s (Node k v l r) = fold f (fold f (f k v s) l) r
